function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === 'function') {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
import { jsx as _jsx } from "react/jsx-runtime";
import NgComponent from 'ngcomponent';
import { StrictMode } from 'react';
import { createRoot } from 'react-dom/client';
const defaultBinding = '<';
const selector = '$element';
/**
 * Wraps a React component in Angular. Returns a new Angular component.
 *
 */ export function react2angular(Class, bindingNames = null, injectNames = []) {
    const names = bindingNames || Class.propTypes && Object.keys(Class.propTypes) || [];
    const bindings = names.reduce((acc, curr)=>{
        acc[curr] = defaultBinding;
        return acc;
    }, {});
    return {
        bindings,
        controller: [
            selector,
            ...injectNames,
            class extends NgComponent {
                static get $$ngIsClass() {
                    return true;
                }
                render() {
                    if (!this.isDestroyed && this.root) {
                        this.root.render(/*#__PURE__*/ _jsx(StrictMode, {
                            children: /*#__PURE__*/ _jsx(Class, _objectSpread({}, this.props, this.injectedProps))
                        }));
                    }
                }
                componentWillUnmount() {
                    this.isDestroyed = true;
                    if (this.root) {
                        this.root.unmount();
                    }
                }
                constructor($element, ...injectedProps){
                    super();
                    this.$element = $element;
                    this.isDestroyed = false;
                    this.injectedProps = {};
                    injectNames.forEach((name, i)=>{
                        this.injectedProps[name] = injectedProps[i];
                    });
                    this.root = createRoot(this.$element[0]);
                }
            }, 
        ]
    };
}


//# sourceMappingURL=index.js.map